#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <piece.h>
unsigned char vbuff[128*88];
static unsigned char draw;

extern unsigned char A[];
extern unsigned char B[];
extern unsigned char C[];

DRAW_OBJECT obj;
PIECE_BMP pbmp1;
PIECE_BMP pbmp2;
PIECE_BMP pbmp3;

#define FORWARD_GO 1
#define BACK_GO    -1

#define KEY_REQUEST   0x80
#define MOUSE_REQUEST 0x81

#define RIGHT_ARROW 0x1c
#define LEFT_ARROW  0x1d
#define UP_ARROW    0x1e
#define DOWN_ARROW  0x1f

typedef struct _usbdata {
  unsigned char datatype; // ̃^Cv́AUSBCOM̃t@NVƏdȂ悤ɂ邱
  char buf[7];
} USBDATA;

USBDATA usbbuff[2];
USBCOMINFO SIG;
int page,prevdiff;

int X,CX,CY;
int COUNT;

void pceAppInit(void)
{
	unsigned char *vram;
	PBMP_FILEHEADER pbhead;
	
	pceLCDDispStop();
	pceLCDSetBuffer(vbuff);
	pceAppSetProcPeriod(10);
	memset(vbuff,0,128*88);
	
	pceFontSetPos(0,0);
	
	draw=1;
	memcpy(&pbhead,A,sizeof(PBMP_FILEHEADER));
	pbmp1.header = pbhead;
	pbmp1.buf = A+sizeof(PBMP_FILEHEADER);
	pbmp1.mask = A+sizeof(PBMP_FILEHEADER)+(pbmp1.header.h*pbmp1.header.w)/4;
	
	memcpy(&pbhead,B,sizeof(PBMP_FILEHEADER));
	pbmp2.header = pbhead;
	pbmp2.buf = B+sizeof(PBMP_FILEHEADER);
	pbmp2.mask = B+sizeof(PBMP_FILEHEADER)+(pbmp2.header.h*pbmp2.header.w)/4;

	memcpy(&pbhead,C,sizeof(PBMP_FILEHEADER));
	pbmp3.header = pbhead;
	pbmp3.buf = C+sizeof(PBMP_FILEHEADER);
	pbmp3.mask = C+sizeof(PBMP_FILEHEADER)+(pbmp3.header.h*pbmp3.header.w)/4;

    pceLCDSetObject(&obj,&pbmp2,0,0,0,0,128,88,DRW_NOMAL);
    pceLCDDrawObject(obj);
    pceLCDSetObject(&obj,&pbmp1,40,0,0,0,48,72,DRW_NOMAL);
    pceLCDDrawObject(obj);
    vram=pceLCDSetBuffer(INVALIDPTR);

	strcpy(SIG.signature,"usbkey");
	pceUSBCOMSetup(&SIG);	// start usb com
	page=0; X=0; COUNT=0; CX=40; CY=0; prevdiff=FORWARD_GO; // dummy
	pceUSBCOMStartRx((unsigned char*)&usbbuff[page],8);

    pceLCDTrans();
    pceLCDDispStart();
}

void pceAppProc(int cnt)
{
	int ptn[]={0,1,2,0,3,4};
    int pp,c,x,lx,ly,lb;
	int status,diffx,diffy;
	int yofs,yhm;

	if (pcePadGet() & PAD_B)
	    pceAppReqExit(0); // if Pad B pushed then terminated.
	if (pcePadGet() & PAD_C) {
	  //USB񂾂ƂɒʐMZbg
	  page=0;
	  pceUSBCOMStop();
	  pceUSBCOMSetup(&SIG);	// start usb com
	  pceUSBCOMStartRx((unsigned char*)&usbbuff[page],8);
	}
	// USB Status Check.
	status=pceUSBCOMGetStat();
	if (status & UCS_RXDONE) {
	  pp=page;  diffx=diffy=0;
	  page=(page + 1 ) & 1;
	  pceUSBCOMStop();
	  pceUSBCOMSetup(&SIG);	// start usb com
	  pceUSBCOMStartRx((unsigned char*)&usbbuff[page],8);  // ΂̃y[WǂݏoJn
	  if (usbbuff[pp].datatype==KEY_REQUEST) {
	    // L[
	    c=usbbuff[pp].buf[0];
	    if ((c=='X') || (c=='x')) {  diffx=FORWARD_GO;  X+=4;   }
	    if ((c=='Z') || (c=='z')) {  X-=4;  diffx=BACK_GO;  }
	    if (c==RIGHT_ARROW) {  CX+=4;  diffx=FORWARD_GO;   }
	    if (c==LEFT_ARROW) {  CX-=4;  diffx=BACK_GO;  }
	    if (c==UP_ARROW) { CY-=2; diffy=BACK_GO; }
	    if (c==DOWN_ARROW) { CY+=2; diffy=FORWARD_GO; }
	  } else if (usbbuff[pp].datatype==MOUSE_REQUEST) {
	    // }EX
	    lb=usbbuff[pp].buf[0]; // {^ԁB
	    lx=(char)usbbuff[pp].buf[1];
	    ly=(char)usbbuff[pp].buf[2];
	    if (lb & 3) {
	      // {^ł肸肵Ƃ͔wiB
	      if (lx>0) {  diffx=FORWARD_GO;  X+=lx; }
	      if (lx<0) {  diffx=BACK_GO;     X+=lx; }
	      if (lb & 1) {
	        // {^ł肸肵Ƃ̓LN^B
	        if (lx>0) {  diffx=FORWARD_GO;  CX+=lx; }
	        if (lx<0) {  diffx=BACK_GO;     CX+=lx; }
	      }
	    } else {
	      //ȂɂĂȂ΂̂܂
	      if (lx>0) {  CX+=lx;  diffx=FORWARD_GO; }
	      if (lx<0) {  CX+=lx;  diffx=BACK_GO;    }
	    }
	    if (ly>0) { CY+=ly; diffy=FORWARD_GO; }
	    if (ly<0) { CY+=ly; diffy=BACK_GO;    }
	  }
      if (CX<0) CX=0;  if (CX>127-48) CX=127-48;
//    if (CY<0) CY=0;	  if (CY>87-72) CY=87-72;
	  if (CY<-71) CY=-71;
	  if (CY>87)  CY=87;
	  if (CY<0)   yofs=-CY;
	  else		  yofs=0;
	  if (CY>87)  yhm=-(CY-87);
	  if (CY<0)   yhm=CY;
	  else        yhm=0;

	  if ((prevdiff!=diffx) && (diffy==0)) COUNT=0;
	  x=X & 0x7f;
	  pceLCDSetObject(&obj,&pbmp2,0,0,x,0,128-x,88,DRW_NOMAL);
      pceLCDDrawObject(obj);
      pceLCDSetObject(&obj,&pbmp2,128-x,0,0,0,x,88,DRW_NOMAL);
      pceLCDDrawObject(obj);
      if (diffx>0)
	    pceLCDSetObject(&obj,&pbmp1,CX,CY,0,72*ptn[COUNT%6]+yofs,48,72+yhm,DRW_NOMAL);
      else if (diffx<0)
	    pceLCDSetObject(&obj,&pbmp3,CX,CY,0,72*ptn[COUNT%6]+yofs,48,72+yhm,DRW_NOMAL);
	  else {
        if (prevdiff>0)
	      pceLCDSetObject(&obj,&pbmp1,CX,CY,0,72*ptn[COUNT%6]+yofs,48,72+yhm,DRW_NOMAL);
	    else
	      pceLCDSetObject(&obj,&pbmp3,CX,CY,0,72*ptn[COUNT%6]+yofs,48,72+yhm,DRW_NOMAL);
	  }
	  if (diffx!=0) prevdiff=diffx;
      pceLCDDrawObject(obj);
      pceLCDTrans();
      COUNT++;
    }
}

void pceAppExit(void)
{
	pceUSBCOMStop();
}
